// <auto-generated>
//     Generated by the protocol buffer compiler.  DO NOT EDIT!
//     source: chat.proto
// </auto-generated>
#pragma warning disable 0414, 1591
#region Designer generated code

using grpc = global::Grpc.Core;

namespace Chat {
  public static partial class ChatService
  {
    static readonly string __ServiceName = "chat.ChatService";

    static void __Helper_SerializeMessage(global::Google.Protobuf.IMessage message, grpc::SerializationContext context)
    {
      #if !GRPC_DISABLE_PROTOBUF_BUFFER_SERIALIZATION
      if (message is global::Google.Protobuf.IBufferMessage)
      {
        context.SetPayloadLength(message.CalculateSize());
        global::Google.Protobuf.MessageExtensions.WriteTo(message, context.GetBufferWriter());
        context.Complete();
        return;
      }
      #endif
      context.Complete(global::Google.Protobuf.MessageExtensions.ToByteArray(message));
    }

    static class __Helper_MessageCache<T>
    {
      public static readonly bool IsBufferMessage = global::System.Reflection.IntrospectionExtensions.GetTypeInfo(typeof(global::Google.Protobuf.IBufferMessage)).IsAssignableFrom(typeof(T));
    }

    static T __Helper_DeserializeMessage<T>(grpc::DeserializationContext context, global::Google.Protobuf.MessageParser<T> parser) where T : global::Google.Protobuf.IMessage<T>
    {
      #if !GRPC_DISABLE_PROTOBUF_BUFFER_SERIALIZATION
      if (__Helper_MessageCache<T>.IsBufferMessage)
      {
        return parser.ParseFrom(context.PayloadAsReadOnlySequence());
      }
      #endif
      return parser.ParseFrom(context.PayloadAsNewBuffer());
    }

    static readonly grpc::Marshaller<global::Chat.Message> __Marshaller_chat_Message = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Chat.Message.Parser));
    static readonly grpc::Marshaller<global::Chat.SendResponse> __Marshaller_chat_SendResponse = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Chat.SendResponse.Parser));
    static readonly grpc::Marshaller<global::Common.UserId> __Marshaller_common_UserId = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Common.UserId.Parser));
    static readonly grpc::Marshaller<global::Chat.Event> __Marshaller_chat_Event = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Chat.Event.Parser));
    static readonly grpc::Marshaller<global::Chat.JoinRequest> __Marshaller_chat_JoinRequest = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Chat.JoinRequest.Parser));
    static readonly grpc::Marshaller<global::Chat.JoinResponse> __Marshaller_chat_JoinResponse = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Chat.JoinResponse.Parser));
    static readonly grpc::Marshaller<global::Chat.LeaveRequest> __Marshaller_chat_LeaveRequest = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Chat.LeaveRequest.Parser));
    static readonly grpc::Marshaller<global::Chat.LeaveResponse> __Marshaller_chat_LeaveResponse = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Chat.LeaveResponse.Parser));
    static readonly grpc::Marshaller<global::Chat.Rooms> __Marshaller_chat_Rooms = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Chat.Rooms.Parser));
    static readonly grpc::Marshaller<global::Chat.RoomRequest> __Marshaller_chat_RoomRequest = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Chat.RoomRequest.Parser));
    static readonly grpc::Marshaller<global::Chat.LastMessagesRequest> __Marshaller_chat_LastMessagesRequest = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Chat.LastMessagesRequest.Parser));
    static readonly grpc::Marshaller<global::Chat.Messages> __Marshaller_chat_Messages = grpc::Marshallers.Create(__Helper_SerializeMessage, context => __Helper_DeserializeMessage(context, global::Chat.Messages.Parser));

    static readonly grpc::Method<global::Chat.Message, global::Chat.SendResponse> __Method_SendMessage = new grpc::Method<global::Chat.Message, global::Chat.SendResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "SendMessage",
        __Marshaller_chat_Message,
        __Marshaller_chat_SendResponse);

    static readonly grpc::Method<global::Common.UserId, global::Chat.Event> __Method_getEventStream = new grpc::Method<global::Common.UserId, global::Chat.Event>(
        grpc::MethodType.ServerStreaming,
        __ServiceName,
        "getEventStream",
        __Marshaller_common_UserId,
        __Marshaller_chat_Event);

    static readonly grpc::Method<global::Chat.JoinRequest, global::Chat.JoinResponse> __Method_JoinRoom = new grpc::Method<global::Chat.JoinRequest, global::Chat.JoinResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "JoinRoom",
        __Marshaller_chat_JoinRequest,
        __Marshaller_chat_JoinResponse);

    static readonly grpc::Method<global::Chat.LeaveRequest, global::Chat.LeaveResponse> __Method_LeaveRoom = new grpc::Method<global::Chat.LeaveRequest, global::Chat.LeaveResponse>(
        grpc::MethodType.Unary,
        __ServiceName,
        "LeaveRoom",
        __Marshaller_chat_LeaveRequest,
        __Marshaller_chat_LeaveResponse);

    static readonly grpc::Method<global::Common.UserId, global::Chat.Rooms> __Method_GetRoomsByUser = new grpc::Method<global::Common.UserId, global::Chat.Rooms>(
        grpc::MethodType.Unary,
        __ServiceName,
        "GetRoomsByUser",
        __Marshaller_common_UserId,
        __Marshaller_chat_Rooms);

    static readonly grpc::Method<global::Chat.RoomRequest, global::Chat.Rooms> __Method_getAllRooms = new grpc::Method<global::Chat.RoomRequest, global::Chat.Rooms>(
        grpc::MethodType.Unary,
        __ServiceName,
        "getAllRooms",
        __Marshaller_chat_RoomRequest,
        __Marshaller_chat_Rooms);

    static readonly grpc::Method<global::Chat.LastMessagesRequest, global::Chat.Messages> __Method_GetLastMessagesByRoom = new grpc::Method<global::Chat.LastMessagesRequest, global::Chat.Messages>(
        grpc::MethodType.Unary,
        __ServiceName,
        "GetLastMessagesByRoom",
        __Marshaller_chat_LastMessagesRequest,
        __Marshaller_chat_Messages);

    /// <summary>Service descriptor</summary>
    public static global::Google.Protobuf.Reflection.ServiceDescriptor Descriptor
    {
      get { return global::Chat.ChatReflection.Descriptor.Services[0]; }
    }

    /// <summary>Base class for server-side implementations of ChatService</summary>
    [grpc::BindServiceMethod(typeof(ChatService), "BindService")]
    public abstract partial class ChatServiceBase
    {
      /// <summary>
      /// Sends a message
      /// </summary>
      /// <param name="request">The request received from the client.</param>
      /// <param name="context">The context of the server-side call handler being invoked.</param>
      /// <returns>The response to send back to the client (wrapped by a task).</returns>
      public virtual global::System.Threading.Tasks.Task<global::Chat.SendResponse> SendMessage(global::Chat.Message request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task getEventStream(global::Common.UserId request, grpc::IServerStreamWriter<global::Chat.Event> responseStream, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Chat.JoinResponse> JoinRoom(global::Chat.JoinRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Chat.LeaveResponse> LeaveRoom(global::Chat.LeaveRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Chat.Rooms> GetRoomsByUser(global::Common.UserId request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Chat.Rooms> getAllRooms(global::Chat.RoomRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

      public virtual global::System.Threading.Tasks.Task<global::Chat.Messages> GetLastMessagesByRoom(global::Chat.LastMessagesRequest request, grpc::ServerCallContext context)
      {
        throw new grpc::RpcException(new grpc::Status(grpc::StatusCode.Unimplemented, ""));
      }

    }

    /// <summary>Client for ChatService</summary>
    public partial class ChatServiceClient : grpc::ClientBase<ChatServiceClient>
    {
      /// <summary>Creates a new client for ChatService</summary>
      /// <param name="channel">The channel to use to make remote calls.</param>
      public ChatServiceClient(grpc::ChannelBase channel) : base(channel)
      {
      }
      /// <summary>Creates a new client for ChatService that uses a custom <c>CallInvoker</c>.</summary>
      /// <param name="callInvoker">The callInvoker to use to make remote calls.</param>
      public ChatServiceClient(grpc::CallInvoker callInvoker) : base(callInvoker)
      {
      }
      /// <summary>Protected parameterless constructor to allow creation of test doubles.</summary>
      protected ChatServiceClient() : base()
      {
      }
      /// <summary>Protected constructor to allow creation of configured clients.</summary>
      /// <param name="configuration">The client configuration.</param>
      protected ChatServiceClient(ClientBaseConfiguration configuration) : base(configuration)
      {
      }

      /// <summary>
      /// Sends a message
      /// </summary>
      /// <param name="request">The request to send to the server.</param>
      /// <param name="headers">The initial metadata to send with the call. This parameter is optional.</param>
      /// <param name="deadline">An optional deadline for the call. The call will be cancelled if deadline is hit.</param>
      /// <param name="cancellationToken">An optional token for canceling the call.</param>
      /// <returns>The response received from the server.</returns>
      public virtual global::Chat.SendResponse SendMessage(global::Chat.Message request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return SendMessage(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      /// <summary>
      /// Sends a message
      /// </summary>
      /// <param name="request">The request to send to the server.</param>
      /// <param name="options">The options for the call.</param>
      /// <returns>The response received from the server.</returns>
      public virtual global::Chat.SendResponse SendMessage(global::Chat.Message request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_SendMessage, null, options, request);
      }
      /// <summary>
      /// Sends a message
      /// </summary>
      /// <param name="request">The request to send to the server.</param>
      /// <param name="headers">The initial metadata to send with the call. This parameter is optional.</param>
      /// <param name="deadline">An optional deadline for the call. The call will be cancelled if deadline is hit.</param>
      /// <param name="cancellationToken">An optional token for canceling the call.</param>
      /// <returns>The call object.</returns>
      public virtual grpc::AsyncUnaryCall<global::Chat.SendResponse> SendMessageAsync(global::Chat.Message request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return SendMessageAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      /// <summary>
      /// Sends a message
      /// </summary>
      /// <param name="request">The request to send to the server.</param>
      /// <param name="options">The options for the call.</param>
      /// <returns>The call object.</returns>
      public virtual grpc::AsyncUnaryCall<global::Chat.SendResponse> SendMessageAsync(global::Chat.Message request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_SendMessage, null, options, request);
      }
      public virtual grpc::AsyncServerStreamingCall<global::Chat.Event> getEventStream(global::Common.UserId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return getEventStream(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncServerStreamingCall<global::Chat.Event> getEventStream(global::Common.UserId request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncServerStreamingCall(__Method_getEventStream, null, options, request);
      }
      public virtual global::Chat.JoinResponse JoinRoom(global::Chat.JoinRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return JoinRoom(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Chat.JoinResponse JoinRoom(global::Chat.JoinRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_JoinRoom, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Chat.JoinResponse> JoinRoomAsync(global::Chat.JoinRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return JoinRoomAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Chat.JoinResponse> JoinRoomAsync(global::Chat.JoinRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_JoinRoom, null, options, request);
      }
      public virtual global::Chat.LeaveResponse LeaveRoom(global::Chat.LeaveRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return LeaveRoom(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Chat.LeaveResponse LeaveRoom(global::Chat.LeaveRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_LeaveRoom, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Chat.LeaveResponse> LeaveRoomAsync(global::Chat.LeaveRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return LeaveRoomAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Chat.LeaveResponse> LeaveRoomAsync(global::Chat.LeaveRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_LeaveRoom, null, options, request);
      }
      public virtual global::Chat.Rooms GetRoomsByUser(global::Common.UserId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetRoomsByUser(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Chat.Rooms GetRoomsByUser(global::Common.UserId request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_GetRoomsByUser, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Chat.Rooms> GetRoomsByUserAsync(global::Common.UserId request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetRoomsByUserAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Chat.Rooms> GetRoomsByUserAsync(global::Common.UserId request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_GetRoomsByUser, null, options, request);
      }
      public virtual global::Chat.Rooms getAllRooms(global::Chat.RoomRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return getAllRooms(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Chat.Rooms getAllRooms(global::Chat.RoomRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_getAllRooms, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Chat.Rooms> getAllRoomsAsync(global::Chat.RoomRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return getAllRoomsAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Chat.Rooms> getAllRoomsAsync(global::Chat.RoomRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_getAllRooms, null, options, request);
      }
      public virtual global::Chat.Messages GetLastMessagesByRoom(global::Chat.LastMessagesRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetLastMessagesByRoom(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual global::Chat.Messages GetLastMessagesByRoom(global::Chat.LastMessagesRequest request, grpc::CallOptions options)
      {
        return CallInvoker.BlockingUnaryCall(__Method_GetLastMessagesByRoom, null, options, request);
      }
      public virtual grpc::AsyncUnaryCall<global::Chat.Messages> GetLastMessagesByRoomAsync(global::Chat.LastMessagesRequest request, grpc::Metadata headers = null, global::System.DateTime? deadline = null, global::System.Threading.CancellationToken cancellationToken = default(global::System.Threading.CancellationToken))
      {
        return GetLastMessagesByRoomAsync(request, new grpc::CallOptions(headers, deadline, cancellationToken));
      }
      public virtual grpc::AsyncUnaryCall<global::Chat.Messages> GetLastMessagesByRoomAsync(global::Chat.LastMessagesRequest request, grpc::CallOptions options)
      {
        return CallInvoker.AsyncUnaryCall(__Method_GetLastMessagesByRoom, null, options, request);
      }
      /// <summary>Creates a new instance of client from given <c>ClientBaseConfiguration</c>.</summary>
      protected override ChatServiceClient NewInstance(ClientBaseConfiguration configuration)
      {
        return new ChatServiceClient(configuration);
      }
    }

    /// <summary>Creates service definition that can be registered with a server</summary>
    /// <param name="serviceImpl">An object implementing the server-side handling logic.</param>
    public static grpc::ServerServiceDefinition BindService(ChatServiceBase serviceImpl)
    {
      return grpc::ServerServiceDefinition.CreateBuilder()
          .AddMethod(__Method_SendMessage, serviceImpl.SendMessage)
          .AddMethod(__Method_getEventStream, serviceImpl.getEventStream)
          .AddMethod(__Method_JoinRoom, serviceImpl.JoinRoom)
          .AddMethod(__Method_LeaveRoom, serviceImpl.LeaveRoom)
          .AddMethod(__Method_GetRoomsByUser, serviceImpl.GetRoomsByUser)
          .AddMethod(__Method_getAllRooms, serviceImpl.getAllRooms)
          .AddMethod(__Method_GetLastMessagesByRoom, serviceImpl.GetLastMessagesByRoom).Build();
    }

    /// <summary>Register service method with a service binder with or without implementation. Useful when customizing the  service binding logic.
    /// Note: this method is part of an experimental API that can change or be removed without any prior notice.</summary>
    /// <param name="serviceBinder">Service methods will be bound by calling <c>AddMethod</c> on this object.</param>
    /// <param name="serviceImpl">An object implementing the server-side handling logic.</param>
    public static void BindService(grpc::ServiceBinderBase serviceBinder, ChatServiceBase serviceImpl)
    {
      serviceBinder.AddMethod(__Method_SendMessage, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Chat.Message, global::Chat.SendResponse>(serviceImpl.SendMessage));
      serviceBinder.AddMethod(__Method_getEventStream, serviceImpl == null ? null : new grpc::ServerStreamingServerMethod<global::Common.UserId, global::Chat.Event>(serviceImpl.getEventStream));
      serviceBinder.AddMethod(__Method_JoinRoom, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Chat.JoinRequest, global::Chat.JoinResponse>(serviceImpl.JoinRoom));
      serviceBinder.AddMethod(__Method_LeaveRoom, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Chat.LeaveRequest, global::Chat.LeaveResponse>(serviceImpl.LeaveRoom));
      serviceBinder.AddMethod(__Method_GetRoomsByUser, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Common.UserId, global::Chat.Rooms>(serviceImpl.GetRoomsByUser));
      serviceBinder.AddMethod(__Method_getAllRooms, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Chat.RoomRequest, global::Chat.Rooms>(serviceImpl.getAllRooms));
      serviceBinder.AddMethod(__Method_GetLastMessagesByRoom, serviceImpl == null ? null : new grpc::UnaryServerMethod<global::Chat.LastMessagesRequest, global::Chat.Messages>(serviceImpl.GetLastMessagesByRoom));
    }

  }
}
#endregion
